#!/usr/bin/perl

$gBaseURL = ".";
$gIconURL = "./images";
$gBaseDIR = ".";
$gCGI_URL = "./wj_board.cgi"; 

$gMakeBoard = "Y"; 	 
$gLockFlag = "N";
$gLockStat = "N";

umask(000);
&parseArgument;
sub parseArgument {
    local($buffer,$data,$name,$value);
    local(@datum);

    if($ENV{'REQUEST_METHOD'} eq "GET") {
        $buffer = $ENV{'QUERY_STRING'};
    }
    else {
        read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
    }

    @datum = split(/&/,$buffer);
    foreach $data (@datum) {
        ($name,$value) = split(/=/,$data);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9]{2})/pack("C",hex($1))/eg;

        $FORM{$name} = $value;
    }
    if($FORM{'id'}) {
        $gBaseDIR = "$gBaseDIR/$FORM{'id'}";
        $gPgTitle = "<img src=$gIconURL/$FORM{'id'}.gif>";
        $gNumFile = "$FORM{'id'}.num";
        $gCfgFile = "$FORM{'id'}.cfg";
        $gPwdFile = "$FORM{'id'}.pwd";
        $gIdxFile = "$FORM{'id'}.idx";
    }
    else {
		&HTMLHeader;

		print "<form name=id>\n";
		print "<table border cellpadding=3 cellspacing=0 width=300 bgcolor=#f3f3f3 bordercolordark=#ffffff bordercolorlight=#c0c0c0>\n";
		print "<tr><td bgcolor=#e3e3e3 align=center><font style=\"font-size:9pt\">- wj_board cgi -</font></td></tr>\n";
		print "<tr><td height=40 align=center><font style=\"font-size:9pt\">  DB  </font><input type=text name=id size=15 class=ad value=$DBname></td></tr>\n";
		print "<tr><td bgcolor=#e3e3e3 align=center>\n";
		print "<input type=submit value=\" DB  \" style=\"height:18px;font-size:9pt;background-color:#f3f3f3;border:1 solid #787878;cursor: hand\" OnClick=\"url_go('$gCGI_URL?id=$DBname')\">\n";
		print "</table></td></tr></table>\n";
		print "</form>\n";

		&HTMLFooter;
    }
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        close(HANDLE);
        &selectAction;
    }
    else {
        if($gMakeBoard eq "Y") {
            &selectAction;
        }
        else {
            &HTMLHeader;
				print "<font style=\"font-size:9pt\">ڿ   Ǿ ϴ!</font>\n";
            &HTMLFooter;
        }
    }
}

sub selectAction {
    &getEnvVar;
    &getNumber;

    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }

    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;
   
    unless($FORM{'action'}) {
        $FORM{'action'} = "read";
    }
    if($FORM{'action'} eq "read") {	
        &readData;
    } 
    elsif($FORM{'action'} eq "input_form") {
        &showInputForm;
    }
    elsif($FORM{'action'} eq "write") {
        if ($gAdminist eq "N"){
            &writeData;
        }
        else {exit;}
    }
    elsif($FORM{'action'} eq "write2") {
        if ($gAdminist eq "Y"){
            &checkAdminPassword;
            &writeData;
        }
        else {exit;}
    } 
    elsif($FORM{'action'} eq "users_login") {
        &showUsersLogin;
    }
    elsif($FORM{'action'} eq "delete") {
        &checkUserPassword;
        &deleteData;
    } 
    elsif($FORM{'action'} eq "update_form") {
        &checkUserPassword;
        &showUpdateForm;
    } 
    elsif($FORM{'action'} eq "update") {
        &updateData;
    } 
    elsif($FORM{'action'} eq "admin_login") {
        &showAdminLogin;
    }
    elsif($FORM{'action'} eq "config_form") {
        &checkAdminPassword;
        &showConfigForm;
    }
    elsif($FORM{'action'} eq "config") {
        &updateEnvVar;
    }
    elsif($FORM{'action'} eq "follow") {
        &HTMLHeader;
        &followData;
            print "<P>\n";
        &readIndexFile;
        &DirectList;
        &HTMLFooter;
    }
    elsif($FORM{'action'} eq "search") {
        &searchData;
    }
    else {
        exit;
    }
}

sub getNumber {
    local($data,$size);
    local(@datum,@value);
   
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        $gNoOfData = <HANDLE>;
        close(HANDLE);
        chop($gNoOfData);
    }
    else {
        mkdir("$gBaseDIR",0777);  
        mkdir("$gBaseDIR/messages",0777);
        
        open(HANDLE,">$gBaseDIR/$gIdxFile");
            print HANDLE "<!--EOF-->\n";
        close(HANDLE);

        $gNoOfData = "0";
        &putNumber;
    } 
}

sub putNumber {
    open(HANDLE,">$gBaseDIR/$gNumFile");
        print HANDLE "$gNoOfData\n";
    close(HANDLE);
}

sub getEnvVar {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gBackColor = $datum[1];
        $gBackImage = $datum[2];
        $gBoardTitle = $datum[3];
        $gBoardImage = $datum[4];
        $gTableWidth = $datum[5];
        $gRecPerPage = $datum[6];
        $gThreadNumber = $datum[7];
        $gMailInform = $datum[8];
        $gAdminEmail = $datum[9];
        $gEmailPgm = $datum[10];
        $gHomeURL = $datum[11];
        $gHomeURLTarget = $datum[12];
        $gBaseText = $datum[13];
        $gLink = $datum[14];
        $gLinkVisited = $datum[15];
        $gLinkActive = $datum[16];
        $gLinkHover = $datum[17];
        $gListHover = $datum[18];
        $gAdminist = $datum[19];
        $gTextSize = $datum[20];
        $gTextFamily = $datum[21];
        $gListNumber = $datum[22];
        $gTableCell = $datum[23];
        $gHeaderText = $datum[24];
        $gTitleColor = $datum[25];
        $gNameMaxlength = $datum[26];
        $gSubjectMaxlength = $datum[27];
        $gScrollbarFace = $datum[28];
        $gScrollbarShadow = $datum[29];
        $gScrollbarHighlight = $datum[30];
        $gScrollbar3dlight = $datum[31];
        $gScrollbarDarkshadow = $datum[32];
        $gScrollbarTrack = $datum[33];
        $gScrollbarArrow = $datum[34];
        $gSkin = $datum[35];
        $gBackImagePosition1 = $datum[36];
        $gBackImagePosition2 = $datum[37];
        chop($gHomeImageURL);
    }
    else {
 
        $gBackColor = "#ffffff";
        $gBackImage = "http://sungji.namwon.net/0.jpg";
        $gBoardTitle = "()  ó Į  ó ";
        $gBoardImage = "";
        $gTableWidth = "85%"; 
        $gRecPerPage = "20";
        $gThreadNumber = "4";
        $gMailInform = "Y";
        $gAdminEmail = "";
        $gEmailPgm = "/usr/sbin/sendmail";
        $gHomeURL = "";
        $gHomeURLTarget = "_self";
        $gBaseText = "#0D00FF"; 
        $gLink = "#0D00FF";
        $gLinkVisited = "#0D00FF";
        $gLinkActive = "#0D00FF";
        $gLinkHover = "#0D00FF";
        $gAdminist = "N";
        $gListHover = "#70CDE8";
        $gAdminist = "N";
        $gTextSize = "9pt";
        $gTextFamily = ",Tahoma";
        $gListNumber = "10";
        $gTableCell = "#70CDE8";
        $gHeaderText = "#ffffff";
        $gTitleColor = "#0D00FF";
        $gNameMaxlength = "8";
        $gSubjectMaxlength = "25";
        $gScrollbarFace = "#ffffff";
        $gScrollbarShadow = "#787878";
        $gScrollbarHighlight = "#c0c0c0";
        $gScrollbar3dlight = "#ffffff";
        $gScrollbarDarkshadow = "#ffffff";
        $gScrollbarTrack = "#ffffff";
        $gScrollbarArrow = "#787878";
        $gSkin = "sungji";
        $gBackImagePosition1 = "right";
        $gBackImagePosition2 = "bottom";
        &putEnvVar;
    }
}
 
sub putEnvVar {
    open(HANDLE,">$gBaseDIR/$gCfgFile");
        print HANDLE "^^|$gBackColor|$gBackImage|$gBoardTitle|$gBoardImage|$gTableWidth|$gRecPerPage|$gThreadNumber|$gMailInform|$gAdminEmail|$gEmailPgm|$gHomeURL|$gHomeURLTarget|$gBaseText|$gLink|$gLinkVisited|$gLinkActive|$gLinkHover|$gListHover|$gAdminist|$gTextSize|$gTextFamily|$gListNumber|$gTableCell|$gHeaderText|$gTitleColor|$gNameMaxlength|$gSubjectMaxlength|$gScrollbarFace|$gScrollbarShadow|$gScrollbarHighlight|$gScrollbar3dlight|$gScrollbarDarkshadow|$gScrollbarTrack|$gScrollbarArrow|$gSkin|$gBackImagePosition1|$gBackImagePosition2|\n";
    close(HANDLE);
}

sub readData {
    &HTMLHeader;
    &PageHeader;
    &readIndexFile;
	&DirectList;
    &showSearchForm;
    &PageFooter;
    &HTMLFooter;
}

sub readIndexFile {
    local($i,$j,$old_date,$new_date,$actual_number,$short_subject,$short_date);
    local(@datum,@value);
    
    print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=1>\n";
    print "<tr valign=middle align=center bgcolor=$gTableCell>\n";
	print "<td align=center><font class=head>no</font></td>\n";
	print "<td align=center><font class=head>subject</font></td>\n";
	print "<td align=center><font class=head>name</font></td>\n";
	print "<td align=center><font class=head>date</font></td>\n";
	print "<td align=center><font class=head>read</font></td></tr>\n";

    open(HANDLE,"$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @value = split(/\|/,$datum[$i]);    
        $actual_number = ($gNoOfData+1)-$i;
        if($actual_number > 0) {

        if($i%2) {
            print "<tr align=center height=22 onmouseover=this.style.backgroundColor='$gListHover' onmouseout=this.style.backgroundColor=''>\n";
		}
        else {
            print "<tr align=center height=22 onmouseover=this.style.backgroundColor='$gListHover' onmouseout=this.style.backgroundColor=''>\n";
        }
            $short_subject = substr($value[2],0,60);
            print "<td align=center>$actual_number</td><td  height=22 align=left>";
            for($j=1;$j<=$value[0];$j++) {
                 print "<img src=$gIconURL/$gSkin/sp.gif align=left>";
            }
            $old_date = substr($value[5],0,10);
            &getDate;
            $new_date = substr($date,0,10);
            if($old_date eq $new_date) {
                if($value[0] == 0) {
                    print "&nbsp;&nbsp;<img src=$gIconURL/$gSkin/item.gif align=absmiddle>&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$value[0]&p=$gCurPage&n=$i&l=$value[1]>$short_subject</a>&nbsp;&nbsp;&nbsp;&nbsp;<img src=$gIconURL/$gSkin/new.gif border=0 align=absmiddle></td>";
                }
                else {
                    print "&nbsp;&nbsp;<img src=$gIconURL/$gSkin/item_reply.gif align=absmiddle>&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$value[0]&p=$gCurPage&n=$i&l=$value[1]>$short_subject</a>&nbsp;&nbsp;&nbsp;&nbsp;<img src=$gIconURL/$gSkin/new.gif border=0 align=absmiddle></td>";
                }
            }
            else {
                if($value[0] == 0) {
                    print "&nbsp;&nbsp;<img src=$gIconURL/$gSkin/item.gif align=absmiddle>&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$value[0]&p=$gCurPage&n=$i&l=$value[1]>$short_subject</a></td>";
                }
                else {
                    print "&nbsp;&nbsp;<img src=$gIconURL/$gSkin/item_reply.gif align=absmiddle>&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$value[0]&p=$gCurPage&n=$i&l=$value[1]>$short_subject</a></td>";
                }
            }
            if ($value[4] eq "<br>") {
                print "<td align=center>$value[3]</td>\n";
            }
            else {
                print "<td align=center><a href=mailto:$value[4] title=\"$value[4]\">$value[3]</a></td>\n";
            }
            $short_date=substr($value[5],0,10);
		    print "<td align=center>$short_date</td>";
		    print "<td align=center>$value[6]</td></tr>";
            print "<tr><td colspan=99 background=$gIconURL/$gSkin/dot.gif width=$gTableWidth height=1></td></tr>\n";
            }
        }
    print "</table>\n";
    unless($gNoOfData) {
        print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=1>\n";
        print "<tr align=center><td colspan=5><font class=importance>do not exist data~~~~ !!!</font>\n";
        print "</table>\n";
    }
}

sub HTMLHeader {
    print "Content-type: text/html\n\n";
    print "<!-------------------------------------------------------->\n";
    print "<!--                                                    -->\n";
    print "<!--    ƾ: ̼                                -->\n";
    print "<!--    ڿ: zeusso\@nownuri.net                    -->\n";
    print "<!--    Ȩ: http://soback.kornet21.net/~zeusso    -->\n";
    print "<!--                                                    -->\n";
    print "<!--    ƾ:                                 -->\n";
    print "<!--    ڿ: thief\@khim.pe.kr                      -->\n";
    print "<!--    Ȩ: http://www.khim.pe.kr/                -->\n";
    print "<!--                                                    -->\n";
    print "<!--    彺Ų: ̼                                -->\n";
    print "<!--    ڿ: sungji\@namwon.net                 -->\n";
    print "<!--    Ȩ: http://sungji.namwon.net                -->\n";
    print "<!--                                                    -->\n";
    print "<!-------------------------------------------------------->\n";
    print "<html>\n";
    print "<head>\n";
    print "    <title> wj_board.cgi </title>\n";
    print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-KR\">\n";
    print "<style type='text/css'>\n";
    print "<!--\n";
    print "    a:link    { color:$gLink;text-decoration:none }\n";
    print "    a:visited { color:$gLinkVisited;text-decoration:none }\n";
    print "    a:active  { color:$gLinkActive;text-decoration:none }\n";
    print "    a:hover   { color:$gLinkHover;text-decoration:underline }\n";
    print "    .here     { background:$gLinkActive;color:$gBackColor }\n" ;
    print "    .link     { background:$gBackColor;color:$gLinkActive }\n" ;
	print "    .tah7     { font-family:Tahoma; font-size:7pt }\n";
	print "    .head     { font-family:Tahoma; font-size:7pt; color:$gHeaderText }\n";
	print "    .importance   { font-family:Tahoma; font-size:8pt; color:#ff0000 }\n";
	print "    .inputdotline { background:; border:solid 0; background-image:url('$gIconURL/$gSkin/dot.gif'); background-repeat:repeat-x; background-position:bottom }\n";
	print "    .submit       { width:60; height:17px; background-color:$gTableCell; border:1 solid $gTableCell; font-family:Tahoma; font-size:7pt; color:$gHeaderText; cursor:hand }\n";
	print "    body      { background:$gBackColor; background-attachment: fixed; background-image: url($gBackImage); background-repeat: no-repeat; background-position: $gBackImagePosition1 $gBackImagePosition2 }\n";
    print "    body,td   { color:$gBaseText;font-size:$gTextSize;font-family:$gTextFamily }\n";
    print "    select,input,form,textarea,option { color:$gBaseText;font-size:$gTextSize }\n";
    print "    body {\n";
    print "        scrollbar-face-color:$gScrollbarFace;\n";
    print "        scrollbar-shadow-color:$gScrollbarShadow;\n"; 
    print "        scrollbar-highlight-color:$gScrollbarHighlight;\n"; 
    print "        scrollbar-3dlight-color:$gScrollbar3dlight;\n"; 
    print "        scrollbar-darkshadow-color:$gScrollbarDarkshadow;\n"; 
    print "        scrollbar-track-color:$gScrollbarTrack;\n";
    print "        scrollbar-arrow-color:$gScrollbarArrow\n";
    print "}\n";
	print "-->\n";
    print "</style>\n";
    print "</head>\n";

    if($gDelayTime == 0) {
        print "<body topmargin=20>\n";
    }
    else {
        print "<meta http-equiv=refresh content=1;url=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>\n";
        print "<body topmargin=20>\n";
    }
    print "<center>\n";    
    if($gBoardImage) {
        print "<img src=$gBoardImage>\n";
    }
    else {
        print "<table border=0 cellspacing=0 cellpadding=0><tr align=center><td>\n";
        print "<script language=\"JavaScript1.2\">\n";
        print "var message=\"$gBoardTitle\"\n";
        print "var neonbasecolor=\"$gBackColor\"\n";
        print "var neontextcolor=\"$gTitleColor\"\n";
        print "var flashspeed=200\n";  
        print "var n=0\n";
        print "   if (document.all){\n";
        print "       document.write('<font color=\"'+neonbasecolor+'\">')\n";
        print "   for (m=0;m<message.length;m++)\n";
        print "       document.write('<span id=\"neonlight\">'+message.charAt(m)+'</span>')\n";
        print "       document.write('</font>')\n";
        print " var tempref=document.all.neonlight\n";
        print "}\n";
        print "    else\n";
        print "        document.write(message)\n";
        print " function neon(){\n";
        print "    if (n==0){\n";
        print "        for (m=0;m<message.length;m++)\n";
        print "            tempref[m].style.color=neonbasecolor\n";
        print "}\n";
        print "        tempref[n].style.color=neontextcolor\n";
        print "    if (n<tempref.length-1)\n";
        print "        n++\n";
        print "    else{\n";
        print "        n=0\n";
        print "        clearInterval(flashing)\n";
        print "        setTimeout(\"beginneon()\",3000)\n";
        print "    return\n";
        print "    }\n";
        print "}\n";
        print " function beginneon(){\n";
        print "    if (document.all)\n";
        print "        flashing=setInterval(\"neon()\",flashspeed)\n";
        print "}\n";
        print " beginneon()\n";
        print "</script>\n";
        print "</td></tr></table>\n";
    }
    print "<br>\n";
}

sub HTMLFooter {
    print "</center>\n";
    print "</body>\n";
    print "</html>\n";
    exit;
}

sub PageHeader {
    print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=2>\n";
    print "<tr><td><font class=tah7><img src=$gIconURL/$gSkin/total.gif border=0><b>$gNoOfData</b> <img src=$gIconURL/$gSkin/stories.gif border=0><b>$gCurPage</b>/<b>$gTotPage</b></font>\n";
    print "<td align=right><a href=$gCGI_URL?id=$FORM{'id'}&action=admin_login&p=$gCurPage&c=config_form><font class=tah7><img src=$gIconURL/$gSkin/admin.gif border=0></font></a> ";
    print "</table>\n";
}

sub PageFooter {
    ### Ʒ  ΰ ϰų  ! ### 
    print "<br><table border=0 cellpadding=0 cellspacing=2>\n";
    print "<tr><td align=center>\n";
    print "<font class=tah7>Created by<a href=http://soback.kornet21.net/~zeusso target=_blank title=\" ϴ Ȩ \"> wonie</a> - <a href=http://www.khim.pe.kr/ target=_blank title=\"  Ȩ \">Khim</a><br>skin by <a href=http://sungji.namwon.net/ target=_blank title=\" ^_^ Ȩ \">Sungji</a></font>\n";
    print "</td></tr>\n";
    print "</table>\n";
}

sub showInputForm {
    local($data,$subject,$content,$name,$myhome,$value);
    local(@value,@cookies);
    
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }

    &HTMLHeader;
    if($FORM{'l'}) {
        open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
            $data = <HANDLE>;
        close(HANDLE);
        @value = split(/\|/,$data);
        $subject = "Re: $value[5]";
        $content = "$value[6]\n ------------- Reply --------------- \n";
        $content =~ s/<br>/\n/g;
        $content =~ s/<p>/\n\n/g;

        print "<form method=post action=$gCGI_URL>\n";    
        print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
        print "<tr><td height=22>&nbsp;&nbsp;&nbsp;&nbsp;<img src=$gIconURL/$gSkin/reply.gif border=0>\n";
        print "<tr><td colspan=99 background=$gIconURL/$gSkin/dot.gif width=$gTableWidth height=1></td></tr>\n";
        print "</table><br>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n";
        print "<input type=hidden name=action value=write>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n"; 
        print "<input type=hidden name=n value=$FORM{'n'}>\n";
        print "<input type=hidden name=l value=$FORM{'l'}>\n"; 
        print "<table width=500 border=0 cellspacing=0 cellpadding=2>\n";
        print "<tr>\n";
        print "<td align=center width=100><font class=tah7><img src=$gIconURL/$gSkin/name.gif></font><td><input name=name value=\"$COOKIE{'UN'}\" type=text size=15 maxlength=$gNameMaxlength class=inputdotline>\n";
        if($COOKIE{'UE'} eq "<br>") {
            $COOKIE{'UE'} = "";
        }
        print "<font class=tah7><img src=$gIconURL/$gSkin/email.gif border=0></font> <input name=email value=\"$COOKIE{'UE'}\" type=text size=15 class=inputdotline>\n";
        print "<tr>\n";    
        print "<td align=center width=100><font class=tah7><img src=$gIconURL/$gSkin/homepage.gif border=0></font>\n";
        print "<td><input name=myhome value=\"$COOKIE{'UH'}\" type=text size=45 maxlength=50 class=inputdotline>\n";
		print "<tr>\n";    
        print "<td align=center width=100><font class=tah7><img src=$gIconURL/$gSkin/subject.gif border=0></font>\n";
        print "<td><input name=subject value=\"$subject\" type=text size=45 maxlength=$gSubjectMaxlength class=inputdotline>\n";    
        print "<tr>\n";
        print "<td align=center><font class=tah7><img src=$gIconURL/$gSkin/comment.gif border=0></font>\n";
        print "<td><font class=tah7><input type=checkbox name=autolink value=enable checked><img src=$gIconURL/$gSkin/autolink.gif border=0> <input type=checkbox name=html value=enable><img src=$gIconURL/$gSkin/usehtml.gif border=0></font><br><textarea name=content rows=10 cols=46 style=\"border:1 $gTableCell solid; background:;\">$content</textarea>\n";
		if ($gAdminist eq "Y"){
			print "<input type=hidden name=action value=write2>\n";
			print "<tr>\n";
			print "<td align=center width=100><font class=tah7><img src=$gIconURL/$gSkin/password.gif border=0></font></td>\n";
			print "<td><input type=password name=oldpasswd size=15 maxlength=8 class=inputdotline> <font class=importance>admin only !!!</font>\n";
		}
		else {
			print "<input type=hidden name=action value=write>\n";
			print "<tr>\n";
			print "<td align=center width=100><font class=tah7><img src=$gIconURL/$gSkin/password.gif border=0></font></td>\n";
			print "<td><input type=password name=passwd size=15 maxlength=8 class=inputdotline> <font class=importance>delete - edit !!!</font>\n";
		}
        print "</table><br>\n";
        print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
        print "<tr><td colspan=99 background=$gIconURL/$gSkin/dot.gif width=$gTableWidth height=1></td></tr>\n";
        print "</table>\n";
        print "<p align=center>\n";
        print "<input type=submit value=\"- write -\"  class=submit> <input type=reset value=\"- reset -\"  class=submit>\n";
        print "</form>\n";
        print "<p align=center><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><font class=tah7><img src=$gIconURL/$gSkin/list.gif border=0></font></a>\n";
    } 
    else {
        print "<form method=post action=$gCGI_URL>\n";    
        print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
        print "<tr><td height=22>&nbsp;&nbsp;&nbsp;&nbsp;<img src=$gIconURL/$gSkin/write.gif>\n";
        print "<tr><td colspan=99 background=$gIconURL/$g/dot.gif width=$gTableWidth height=1></td></tr>\n";
        print "</table><br>\n"; 
        print "<input type=hidden name=id value=$FORM{'id'}>\n";
        print "<input type=hidden name=action value=write>\n";
        print "<input type=hidden name=n value=$FORM{'n'}>\n";
        print "<input type=hidden name=p value=1>\n";
        print "<table width=500 border=0 cellspacing=0 cellpadding=2>\n";
        print "<tr>\n";
        print "<td align=center width=100><font class=tah7><img src=$gIconURL/$gSkin/name.gif></font><td><input name=name value=\"$COOKIE{'UN'}\" type=text size=15 maxlength=$gNameMaxlength class=inputdotline>\n";
        print "<font class=tah7><img src=$gIconURL/$gSkin/email.gif border=0></font> <input name=email value=\"$COOKIE{'UE'}\" type=text size=15 class=inputdotline>\n";
        print "<tr>\n";    
        print "<td align=center width=100><font class=tah7><img src=$gIconURL/$gSkin/homepage.gif border=0></font>\n";
        print "<td><input name=myhome value=\"$COOKIE{'UH'}\" type=text size=45 maxlength=50 class=inputdotline>\n";
        print "<tr>\n";    
        print "<td align=center width=100><font class=tah7><img src=$gIconURL/$gSkin/subject.gif border=0></font>\n";
        print "<td><input name=subject type=text size=45 maxlength=$gSubjectMaxlength class=inputdotline>\n";
        print "<tr>\n";
        print "<td align=center><font class=tah7><img src=$gIconURL/$gSkin/comment.gif border=0></font>\n";
        print "<td><font class=tah7><input type=checkbox name=autolink value=enable checked><img src=$gIconURL/$gSkin/autolink.gif border=0> <input type=checkbox name=html value=enable><img src=$gIconURL/$gSkin/usehtml.gif border=0></font><br><textarea name=content rows=10 cols=46 style=\"border:1 $gTableCell solid; background:;\"></textarea>\n";
        if ($gAdminist eq "Y"){
            print "<input type=hidden name=action value=write2>\n";
            print "<tr>\n";
            print "<td align=center width=100><font class=tah7><img src=$gIconURL/$gSkin/password.gif border=0></font></td>\n";
            print "<td><input type=password name=oldpasswd size=15 maxlength=8 class=inputdotline> <font class=importance>admin only !!!</font>\n";
        }
        else {
            print "<input type=hidden name=action value=write>\n";
		    print "<tr>\n";
            print "<td align=center width=100><font class=tah7><img src=$gIconURL/$gSkin/password.gif border=0></font></td>\n";
            print "<td><input type=password name=passwd size=20 maxlength=8 class=inputdotline> <font class=importance>delete - edit !!!</font>\n";
        }
        print "</table><br>\n";
        print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
        print "<tr><td colspan=99 background=$gIconURL/$gSkin/dot.gif width=$gTableWidth height=1></td></tr>\n";
        print "</table>\n";
        print "<p align=center>\n";
        print "<input type=submit value=\"- write -\"  class=submit> <input type=reset value=\"- reset -\"  class=submit>\n";
        print "</form>\n";
        print "<p align=center><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><font class=tah7><img src=$gIconURL/$gSkin/list.gif border=0></font></a>\n";
    } 
    &HTMLFooter;
}

sub writeData {
    &getNumber;
    &getVariable;

    print "Set-Cookie: UN=$name; expires=Sunday, 12-Dec-9999 12:12:12 GMT;\r\n";
    print "Set-Cookie: UE=$email; expires=Sunday, 12-Dec-9999 12:12:12 GMT;\r\n" unless($email eq "<br>");
    print "Set-Cookie: UH=$myhome; expires=Sunday, 12-Dec-9999 12:12:12 GMT;\r\n" unless($myhome eq "");

	&makeCryptPassword if($passwd);
    &appendIndexFile;
    &makeNewFile;
    &sendMail if($gAdminEmail);
    $gNoOfData++;
    &putNumber;

    $gDelayTime = 500;
    &HTMLHeader;
        print "<p><font class=importance>thanks so mush.. esquire $name ^^;</font>\n";
        print "<p><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><font class=tah7>- go to board -</font></a>\n";
    &HTMLFooter;
}

sub getVariable {
    if($FORM{'passwd'}) {
        $passwd = "$FORM{'passwd'}";
    }
    unless($FORM{'name'} =~ /^\s*$/) {
        $name = "$FORM{'name'}";
        $name =~ s/</&lt;/g;
        $name =~ s/>/&gt;/g;
        $name =~ s/"/&quot;/g;
        $name =~ s/\|/&#124;/g;
    }
    else {
        &error(no_name);
    }
    if($FORM{'email'} =~ /^.+\@.+(\..+)+/) {
        $email = "$FORM{'email'}";
        $email =~ s/</&lt;/g;
        $email =~ s/>/&gt;/g;
        $email =~ s/"/&quot;/g;
        $email =~ s/\|/&#124;/g;
    }
    else {
        $email = "<br>";
    }
    unless($FORM{'subject'} =~ /^\s*$/) {
        $subject = "$FORM{'subject'}";
        $subject =~ s/</&lt;/g;
        $subject =~ s/>/&gt;/g;
        $subject =~ s/"/&quot;/g;
        $subject =~ s/\|/&#124;/g;
    }
    else {
        &error(no_subject);
    }
    if($FORM{'content'}) {
        $content = "$FORM{'content'}";
        if($FORM{'html'} ne "enable") { 
            $content =~ s/</&lt;/g;
            $content =~ s/>/&gt;/g;
            $content =~ s/"/&quot;/g;
            $content =~ s/\|/&#124;/g;
        }
        if ($FORM{'autolink'} eq "enable"){
            $content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.gif)/<img src=\"\/\/$2\">/gi;
            $content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.jpg)/<img src=\"\/\/$2\">/gi;
            $content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.bmp)/<img src=\"\/\/$2\">/gi;
            $content =~ s/(http:\/\/)([\w\~+\-\/\=\?\.\~\:]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
            $content =~ s/(ftp:\/\/)([\w\~+\-\/\=\?\.\~]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
            $content =~ s/(telnet:\/\/)([\w\~+\-\/\=\?\.\~]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
            $content =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/<a href=\"mailto:$1\">$1<\/a>/gi;
		}
        $content =~ s/\r\n\r\n/<p>/g;
        $content =~ s/\r\n/<br>/g;
        $content =~ s/\|/&#124;/g;
    }
    else {
        &error(no_content);
    }
    if($FORM{'myhome'}) {
        $myhome = "$FORM{'myhome'}";
        $myhome =~ s/</&lt;/g;
        $myhome =~ s/>/&gt;/g;
        $myhome =~ s/"/&quot;/g;
        $myhome =~ s/\|/&#124;/g;
    }
    else {
        $myhome = "";
    }
    &getDate;
}

sub getDate {     
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

    if($sec < 10) {
        $sec = "0$sec";
    }
    if($min < 10) {
        $min = "0$min";
    }
    if($hour < 10) {
        $hour = "0$hour";
    }
    $mon++;
    if($mon < 10) {
        $mon = "0$mon";
    }
    if($mday < 10) {
        $mday = "0$mday";
    }
    $year = $year + 1900;
    $date = "$year-$mon-$mday $hour:$min:$sec";
    $d = "$mon$mday";
}      

sub makeCryptPassword  {
    local($crypt_code);
    local(@set);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $gCryptPassword = crypt($passwd,$crypt_code);
}

sub makeNewFile { 
    open(HANDLE,">$gBaseDIR/messages/$filename.txt");
        print HANDLE "$gCryptPassword|$filename|$name|$email|$date|$subject|$content|$myhome\n";
    close(HANDLE);
}

sub appendIndexFile {
    local($data);
    local(@set,@datum,@value);
    
    @set = ('0'..'9');
    srand(time);
    $filename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";

    open(HANDLE,"<$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    &lock;
    if($FORM{'l'}) {    
        open(HANDLE,">$gBaseDIR/$gIdxFile");
        foreach $data (@datum) {
            @value = split(/\|/,$data);
            if($value[1] eq $FORM{'l'}) {
                $thread = $value[0] + 1;
                print HANDLE "$data";
                print HANDLE "$thread|$filename|$subject|$name|$email|$date|0\n";
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    else {
        $thread = 0;
        open(HANDLE,">$gBaseDIR/$gIdxFile");
        foreach $data (@datum) {
            if($data =~ /<!--EOF-->/) {
                print HANDLE "<!--EOF-->\n";
	        print HANDLE "$thread|$filename|$subject|$name|$email|$date|0\n";
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    &unlock;
}

sub sendMail {
    open(MAIL,"|$gEmailPgm -t $gAdminEmail");
    print MAIL "To: $gAdminEmail\n";
    print MAIL "From: $name<$email>\n";
    print MAIL "Subject: $subject\n";
    $content =~ s/<p>/\n\n/g;
    $content =~ s/<br>/\n/g;
    print MAIL "$name wrote on $date";
    print MAIL "\n--------------------------------------------------\n";
    print MAIL "$content"; 
    print MAIL "\n--------------------------------------------------\n";
    close(MAIL);
}

sub error {
    local($error) = $_[0];

    &HTMLHeader;
    if($error eq "no_name") {
        print "<p><font class=importance>be positively necessary.... your name !!!</font>\n";
        print "<p><a href=\"javascript:history.back()\"><font class=tah7>- go to back -</font></a>\n";
    }
    elsif ($error eq "no_subject") {
        print "<p><font class=importance>be positively necessary.... your subject !!!</font>\n";
        print "<p><a href=\"javascript:history.back()\"><font class=tah7>- go to back -</font></a>\n";
    }
    else {
        print "<p><font class=importance>be positively necessary.... your comment !!!</font>\n";
        print "<p><a href=\"javascript:history.back()\"><font class=tah7>- go to back -</font></a>\n";
    }
    &HTMLFooter;
}

sub followData {
    local($PrevNum,$PrevPage,$CurrNum,$NextNum,$NextPage,$data,$seen);
    local(@datum,@value,@PrevLine,@CurrLine,@NextLine);

    open(HANDLE,"$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);
    $PrevNum = $FORM{'n'}-1;
    $PrevPage = int(($PrevNum-1)/$gRecPerPage)+1;
    @PrevLine = split(/\|/,$datum[$PrevNum]);
   
    $CurrNum = $FORM{'n'};
    @CurrLine = split(/\|/,$datum[$CurrNum]); 

    $NextNum = $FORM{'n'}+1;
    $NextPage = int(($NextNum-1)/$gRecPerPage)+1;
    @NextLine = split(/\|/,$datum[$NextNum]);

	$gDataNumber = $FORM{'l'};
    &addHitCounter;

    open(HANDLE,"$gBaseDIR/messages/$gDataNumber.txt");
        $data = <HANDLE>;
    close(HANDLE);
	@value = split(/\|/,$data);             

    $actual_number = ($gNoOfData+1)-$FORM{'n'};
    print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=0>\n";
    $seen = substr($CurrLine[6],0,4);
    print "<tr valign=middle align=center bgcolor=$gTableCell><td align=left>&nbsp;&nbsp;<font class=head># $actual_number&nbsp;&nbsp;read: $seen</font>&nbsp;&nbsp;\n"; 
    if($value[3] eq "<br>") {
        print ""; 
    }
    else {
        print "<a href=mailto:$value[3] title=\"$value[2]Բ \"><font class=head>$value[3]</font></a>&nbsp;&nbsp;";
    }
    if($value[7] =~ /http:\/\/.+/) {
        $myhome = "$value[7]";
    }
    else {
        $myhome = "http://$value[7]";
    }
    if($value[7] eq "") {
        print "";
    }
    else {
        print "<a href=\"$myhome\" target=\"_blank\" title=\"$value[2] Ȩ\"><font class=head>$myhome</font></a>&nbsp;&nbsp;";
    }
    print "<td align=right><a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&c=update_form&p=$FORM{'p'}&n=$CurrNum&l=$gDataNumber title=\"ϱ\"><font class=head>edit</font></a>&nbsp;&nbsp;";
    if($CurrLine[0] < $NextLine[0]) {
	    print "<font class=head>delete</font>&nbsp;&nbsp;\n";
    }
    else {
	    print "<a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&c=delete&p=$FORM{'p'}&n=$CurrNum&l=$gDataNumber title=\"ϱ\"><font class=head>delete</font></a>&nbsp;&nbsp;\n";
    }
	print "<tr><td align=center colspan=2><br>$value[5] - $value[2]</td></tr>\n";
    print "</table>\n";
	print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=10>\n";
    print "<tr><td><div style=line-height:140%>$value[6]</div>";
    print "<tr><td align=right><font class=tah7>$value[4]</font></font>\n";
    print "</table>\n";

	print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=0>\n";
    if($PrevNum >= 1) {
        print "<tr><td colspan=99 background=$gIconURL/$gSkin/dot.gif width=$gTableWidth height=1></td></tr>\n";
        print "<tr height=22 align=left><td>\n";
        print "&nbsp;&nbsp;<font class=tah7>prev</font>  <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$PrevLine[0]&p=$PrevPage&n=$PrevNum&l=$PrevLine[1]>$PrevLine[2]<td align=right>&nbsp;&nbsp;\n";
    }
    if($NextNum <= $gNoOfData) { 
        print "<tr><td colspan=99 background=$gIconURL/$gSkin/dot.gif width=$gTableWidth height=1></td></tr>\n";
        print "<tr height=22 align=left><td>\n";
        print "&nbsp;&nbsp;<font class=tah7>next</font>  <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$NextLine[0]&p=$NextPage&n=$NextNum&l=$NextLine[1]>$NextLine[2]</a><td align=right>&nbsp;&nbsp;\n";
    }
    print "<tr><td colspan=99 background=$gIconURL/$gSkin/dot.gif width=$gTableWidth height=1></td></tr>\n";
    print "</table>\n";

    print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=2>\n";
    print "<tr><td align=left>&nbsp;&nbsp;\n";
    print "<font class=tah7><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><img src=$gIconURL/$gSkin/list.gif border=0></a></font>\n";
    print "<td align=right>\n";
    if($FORM{'f'} < $gThreadNumber-1) {
        print "<font class=tah7><a href=$gCGI_URL?id=$FORM{'id'}&action=input_form&p=$FORM{'p'}&n=$CurrNum&l=$gDataNumber><img src=$gIconURL/$gSkin/reply.gif border=0></a></font>&nbsp;&nbsp;\n";
    }
    else {
        print "<font class=tah7><img src=$gIconURL/$gSkin/reply.gif border=0></font>&nbsp;\n";
    }
    print "</table><br><br>\n";
}
sub DirectList  {
	print "<table border=0 cellpadding=2 cellspacing=0 width=$gTableWidth><tr>\n";
    print "<td><font class=tah7>";
	$term = $gListNumber;$f = 1;$l = $term;while ($f <= $gTotPage) {
		if (($f <= $gCurPage) && ($gCurPage <= $l)) {
			$PrevPage = $f - 1;
			if ($PrevPage > 0) {
				print "<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$PrevPage>prev $gListNumber page</a> ..";
			}
			if ($l <= $gTotPage) {
				for ($page = $f; $page <= $l; $page++) {
					if ($page == $gCurPage) {
						print "<font class=here>&nbsp;$page </font>";
					}
					else {
						print "<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$page><font class=link>&nbsp;$page </font></a>";
					}
				}
			}
			else {
				for ($page = $f; $page <= $gTotPage; $page++) {
					if ($page == $gCurPage) {
						print "<font class=here>&nbsp;$page </font>";
					}
					else {
						print "<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$page><font class=link>&nbsp;$page </font></a>";
					}
				}
			}
			$NextPage = $l + 1;
			if ($NextPage <= $gTotPage) {
				print ".. <a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$NextPage>next $gListNumber page</a>";
			}
		}
		$f = $f + $term;
		$l = $l + $term;
	}
	print "</font></td>\n";
	print "<td align=right>\n";
	print "<font class=tah7><a href=$gCGI_URL?id=$FORM{'id'}&action=input_form><img src=$gIconURL/$gSkin/write.gif border=0></a>&nbsp;&nbsp;\n";
	print "<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><img src=$gIconURL/$gSkin/reload.gif border=0></a></font>&nbsp;&nbsp;";
	if($gHomeURL) {
		print "<font class=tah7><a href=$gHomeURL target=$gHomeURLTarget><img src=$gIconURL/$gSkin/homepage.gif border=0></a></font>&nbsp;&nbsp;"; 
	}
	print "</table>\n";
}

sub addHitCounter {
    local($data,$temp);
    local(@datum,@value,@t);

    open(HANDLE,"<$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    &lock;
    open(HANDLE,">$gBaseDIR/$gIdxFile");   
    foreach $data (@datum) {
        @value = split(/\|/,$data);             
        if ($value[1] eq $gDataNumber) {
            $value[6]++;
	    print HANDLE "$value[0]|$value[1]|$value[2]|$value[3]|$value[4]|$value[5]|$value[6]\n";
        }
        else {
             print HANDLE $data;
        }
    }
    close(HANDLE);
    &unlock;

    open(HANDLE,"<$gBaseDIR/messages/$gDataNumber.txt");
        $temp = <HANDLE>;
    close(HANDLE);
    @t = split(/\|/, $temp);

    $t[8] = $t[8] + 1;
    open(HANDLE,">$gBaseDIR/messages/$gDataNumber.txt");
        print HANDLE "$t[0]|$t[1]|$t[2]|$t[3]|$t[4]|$t[5]|$t[6]|$t[7]|$t[8]|$t[9]";
    close(HANDLE);
}

sub searchData {
    local($data,$counter);
    local(@datum,@value);    

    &getNumber;
    &HTMLHeader;
    unless($FORM{'word'}) {
        print "<p><font class=importance>do not exist word</font>\n";
        print "<p><a href=\"javascript:history.back()\"><font class=tah7>- go to back -</font></a>\n";
    }
    else {
        print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=1>\n";
        print "<tr valign=middle align=center bgcolor=$gTableCell>\n";
	    print "<td align=center><font class=head>no</font></td>\n";
	    print "<td align=center><font class=head>subject</font></td>\n";
	    print "<td align=center><font class=head>name</font></td>\n";
	    print "<td align=center><font class=head>date</font></td>\n";
	    print "<td align=center><font class=head>read</font></td></tr>\n";

        open(HANDLE,"$gBaseDIR/$gIdxFile");
            @datum = <HANDLE>;
        close(HANDLE);

        $counter = 0 ;
        for($i=1;$i<=$gNoOfData;$i++ ) {
            @v = split(/\|/,$datum[$i]);            
            open(HANDLE,"$gBaseDIR/messages/$v[1].txt");
                $data = <HANDLE>;
            close(HANDLE);

            @value = split(/\|/,$data);
            if($FORM{'cp'} eq 'subject') {  
                if($value[5] =~ /$FORM{'word'}/i) {
                    &printRecord;
                    $counter++;
                }
            }
	    elsif($FORM{'cp'} eq "name") { 
	        if($value[2] =~ /$FORM{'word'}/i) {
                    &printRecord;
                    $counter++;
		}
            } 
	    else { 
	        if($value[6] =~ /$FORM{'word'}/i) {
                    &printRecord;
                    $counter++;
                }
            }
		}
        print "<tr><td colspan=5 align=center  height=22>\n";
        print "˻ <b>$FORM{'word'}</b>()  $counter Խù ˻Ǿϴ\n";
        print "</table>\n";
        print "<br><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><font class=tah7><img src=$gIconURL/$gSkin/list.gif border=0></font></a>\n";
    } 
    &HTMLFooter;  
}

sub printRecord {
    local($short_subject,$short_date,$actual_number);

    $actual_number = ($gNoOfData+1)-$i;
        print "<tr height=22 align=center onMouseOver=this.style.backgroundColor='$gListHover' onMouseOut=this.style.backgroundColor=''><td>$actual_number\n";
    $short_subject = substr($v[2],0,50);
    if ($v[0] == 0) {
        print "<td align=left>&nbsp;&nbsp;<img src=$gIconURL/$gSkin/item.gif align=absmiddle>&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=0&p=$FORM{'p'}&n=$i&l=$v[1]>$short_subject</a>";
    }
    else {
        print "<td align=left>&nbsp;&nbsp;&nbsp;&nbsp;<img src=$gIconURL/$gSkin/item_reply.gif align=absmiddle>&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=1&p=$FORM{'p'}&n=$i&l=$v[1]>$short_subject</a>";
    } 
    if ($v[4] eq "<br>") {
        print "<td align=center>$v[3]\n";
    }
    else {
        print "<td align=center><a href=mailto:$v[4] title=\"$v[4]\">$v[3]</a>\n";
    }
    $short_date = substr($v[5],0,10);
        print "<td align=center>$short_date";
        print "<td align=center>$v[6]";
        print "<tr><td colspan=99 background=$gIconURL/$gSkin/dot.gif width=$gTableWidth height=1></td></tr>\n";
}

sub showSearchForm {
    print "<form method=post action=$gCGI_URL>\n";
    print "<table border=0 width=300 cellspacing=0 cellpadding=1>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=search>\n";
    print "<input type=hidden name=p value=$gCurPage>\n";
    print "<tr align=center valign=middle><td>\n";
    print "<select name=cp value=search style=\"font-size:7pt;font-family:Tahoma;background:$gBackColor;\">\n";
    print "<option name=cp value=subject>subject\n";
    print "<option name=cp value=name>name\n";
    print "<option name=cp value=content>comment\n";
    print "</select>\n";
    print "<input type=text size=16 name=word style=\"height:17px; background:; border:1 $gTableCell solid\"><input type=submit value='- search -' class=submit>\n";
    print "</table>\n";
}

sub showUsersLogin {
    local($command);

    if($FORM{'c'} eq "delete") {
        $command = "delete";
    }
    else {
        $command = "update_form";
    }
 
    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";
    print "<input type=hidden name=n value=$FORM{'n'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<font class=importance>user password~~~~ !!!</font><br>\n";
    print "<input type=password name=passwd size=25 maxlength=8 style=\"height:18px; background:; border:1 $gTableCell solid\"><br>\n";
    print "<input type=submit value=\"- submit -\" class=submit>\n" if($command eq "delete");
    print "<input type=submit value=\"- submit -\" class=submit>\n" if($command eq "update_form");
    print "</form>\n";
    &HTMLFooter;       
}

sub checkUserPassword {
    local($data,$crypt_code,$save_password,$crypt_password);
    local(@passwd,@set,@datum,@value);
 
    open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
        $data = <HANDLE>;
    close(HANDLE);
    @passwd = split(/\|/,$data);

    open(HANDLE,"$gBaseDIR/$gPwdFile");
        $save_password = <HANDLE>;
    close(HANDLE);
    chop($save_password);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $crypt_password = crypt($FORM{'passwd'},$crypt_code);

    unless($crypt_password eq $passwd[0] || $crypt_password eq $save_password) {
        &HTMLHeader;
            print "<p><font class=importance>erroneous user password~~~~ !!!</font>\n";        
            print "<p><a href=\"javascript:history.back()\"><font class=tah7>- go to back -</font></a>\n";
        &HTMLFooter;
    } 
}

sub deleteData {
    local(@datum,@value);
    unless(-e "$gBaseDIR/messages/$FORM{'l'}.txt") {
	    $gDelayTime = 500;
        &HTMLHeader;
            print "<p><font class=importance>delete data~~~~ !!!</font>\n";
            print "<p><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><font class=tah7>- go to board -</font></a>\n";
        &HTMLFooter;
    }

    open(HANDLE,"$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    if($#datum <= 1) {
        open(HANDLE,">$gBaseDIR/messages/00000000");
            print HANDLE "99999999\n";
        close(HANDLE);
    }
    else {
        if($FORM{'n'} == 1) {
            @value = split(/\|/, $datum[2]);
            open(HANDLE,">$gBaseDIR/messages/00000000");
               print HANDLE "$value[1]\n";
            close(HANDLE);
        }
        else {
            if($FORM{'n'} == $#datum) {
                $link = "99999999";
            }
            else {
                @value = split(/\|/, $datum[$FORM{'n'}+1]);
                $link = $value[1];
            }

            @value = split(/\|/, $datum[$FORM{'n'}-1]);
            open(HANDLE,"<$gBaseDIR/messages/$value[1].txt");
                $data = <HANDLE>;
            close(HANDLE);

            @value = split(/\|/, $data);
            open(HANDLE,">$gBaseDIR/messages/$value[1].txt");
            print HANDLE "$value[0]|$value[1]|$value[2]|$value[3]|$value[4]|$value[5]|$value[6]|$value[7]|$link\n";
            close(HANDLE);
        }
    }
    &lock;
    open(HANDLE,">$gBaseDIR/$gIdxFile");
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} ne $value[1]) {
            print HANDLE "$data";             
        }
    }
    close(HANDLE);
    &unlock;
    unlink("$gBaseDIR/messages/$FORM{'l'}.txt");
    $gNoOfData--;
    &putNumber;

    $gDelayTime = 500;
    &HTMLHeader;
        print "<p><font class=importance>delete data~~~~ !!!</font>\n";
        print "<p><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><font class=tah7>- go to board -</font></a>\n";
    &HTMLFooter;
}

sub showUpdateForm {
    local($data);
    local(@value);
 
    open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
    print "<input type=hidden name=action value=update>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td height=22>&nbsp;&nbsp;&nbsp;&nbsp;<img src=$gIconURL/$gSkin/edit.gif border=0>---\n";
    print "<tr><td colspan=99 background=$gIconURL/$gSkin/dot.gif width=$gTableWidth height=1></td></tr>\n";
    print "</table><br>\n";
    print "<table width=500 border=0 cellspacing=0 cellpadding=2>\n";
    print "<tr>\n";
    print "<td align=center width=100><font class=tah7>name</font>\n";
    print "<td><input name=name type=text size=15 maxlength=$gNameMaxlength value=\"$value[2]\" class=inputdotline>\n";
    $value[3] =~ s/<br>//g;
    print "<font class=tah7><img src=$gIconURL/$gSkin/email.gif border=0></font> <input name=email type=text size=15 value=\"$value[3]\" class=inputdotline>\n";
    print "<tr>\n";    
    print "<td align=center width=100><font class=tah7><img src=$gIconURL/$gSkin/homepage.gif border=0></font>\n";
    print "<td><input name=myhome value=\"$value[7]\" type=text size=45 maxlength=50 class=inputdotline>\n";
    print "<tr>\n";    
    print "<td align=center width=100><font class=tah7>subject</font>\n";
    print "<td><input name=subject type=text size=45 maxlength=$gSubjectMaxlength value=\"$value[5]\" class=inputdotline>\n";    
    print "<tr>\n";
    print "<td align=center><font class=tah7>comment</font>\n";
    $value[6] =~ s/<br>/\n/g;
    $value[6] =~ s/<p>/\n\n/g;
    print "<td><font class=tah7><input type=checkbox name=autolink value=enable checked><img src=$gIconURL/$gSkin/autolink.gif border=0> <input type=checkbox name=html value=enable><img src=$gIconURL/$gSkin/usehtml.gif border=0></font><br><textarea name=content rows=10 cols=46 style=\"border:1 $gTableCell solid; background:;\">$value[6]</textarea>\n";
    print "</table><br>\n";
    print "<table width=500 border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td colspan=99 background=$gIconURL/$gSkin/dot.gif width=$gTableWidth height=1></td></tr>\n";
    print "</table>\n";
    print "<p align=center>\n";
    print "<input type=submit value=\"- write -\"  class=submit> <input type=reset value=\"- reset -\"  class=submit>\n";
    print "</form>\n";
    print "<p align=center><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><font class=tah7><img src=$gIconURL/$gSkin/list.gif border=0></font></a>\n";
    &HTMLFooter;       
}

sub updateData {
    local($temp);
    local(@datum,@value,@t);
  
    &getVariable;
    open(HANDLE,"<$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    &lock;
    open(HANDLE,">$gBaseDIR/$gIdxFile");
    foreach $data (@datum) {
        @value = split(/\|/,$data);
        if($FORM{'l'} eq $value[1]) {
            print HANDLE "$value[0]|$FORM{'l'}|$subject|$name|$email|$date|$value[6]";
        }
        else {
            print HANDLE "$data";
        }
    }
    close(HANDLE);
    &unlock;

    open(HANDLE,"<$gBaseDIR/messages/$FORM{'l'}.txt");
        $temp = <HANDLE>;
    close(HANDLE);
    @t = split(/\|/, $temp);

    open(HANDLE,">$gBaseDIR/messages/$FORM{'l'}.txt");
        print HANDLE "$t[0]|$FORM{'l'}|$name|$email|$date|$subject|$content|$myhome|$t[8]|$t[9]";
    close(HANDLE);

    $gDelayTime = 500;
    &HTMLHeader;
        print "<p><font class=importance>edit data~~~~ !!!</font>\n";
        print "<p><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}><font class=tah7>- go to board -</font></a>\n";
    &HTMLFooter;
}

sub showAdminLogin {
    &HTMLHeader;
    unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
        print "<form action=$gCGI_URL>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n";    
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=new>\n";
        print "<font class=importance>admin password~~~~ !!!</font>\n";
        print "<table>\n";
        print "<tr align=center><td height=60 width=400>\n";
        print "<font class=importance>password</font>&nbsp;<input type=password name=newpasswd size=20 maxlength=8 style=\"height:18px; background:; border:1 $gTableCell solid\"><br>\n";
        print "<font class=importance>re_pass</font>&nbsp;&nbsp;&nbsp;<input type=password name=repasswd size=20 maxlength=8 style=\"height:18px; background:; border:1 $gTableCell solid\"><br>\n";
        print "</table>\n";
        print "<input type=submit value=\"- submit -\" class=submit>\n";
        print "</form>\n";
    }
    else {
        print "<form method=post action=$gCGI_URL>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=old>\n";
        print "<font class=importance>admin password~~~~ !!!</font><br>\n";
        print "<input type=password name=oldpasswd size=25 maxlength=8 style=\"height:18px; background:; border:1 $gTableCell solid\"><br>\n";
        print "<input type=submit value=\"- submit -\" class=submit>\n";
        print "</form>\n";
    }
    close(HANDLE);
    &HTMLFooter;
}
 
sub checkAdminPassword {
    local($crypt_code,$save_password,$old_password,$new_password);
    local(@set);
    
    if($FORM{'ps'} eq "new") {  
        if($FORM{'newpasswd'} eq $FORM{'repasswd'}) {
            if($FORM{'newpasswd'} ne "") {
                @set = ('a'..'z','A'..'Z','0'..'9','.','/');
                $crypt_code = "$set[9]$set[3]";
                $save_password = crypt($FORM{'newpasswd'},$crypt_code);
                open(HANDLE,">$gBaseDIR/$gPwdFile");
                    print HANDLE "$save_password\n";
	                close(HANDLE);
            }
            else {
                &HTMLHeader;
                    print "<p><font class=importance>erroneous admin password~~~~ !!!</font>\n";
                    print "<p><a href=\"javascript:history.back()\"><font class=tah7>- go to back -</font></a>\n";
                &HTMLFooter;
            }
        }
        else {
            &HTMLHeader;
                print "<p><font class=importance>admin only~~~~ !!!</font>\n";
                print "<p><a href=\"javascript:history.back()\"><font class=tah7>- go to back -</font></a>\n";
            &HTMLFooter;
        } 
    } 

    else { 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
                print "<p><font class=importance>erroneous admin password~~~~ !!!</font>\n";
                print "<p><a href=\"javascript:history.back()\"><font class=tah7>- go to back -</font></a>\n";
            &HTMLFooter;
        }
    }
}

sub showConfigForm {
    &HTMLHeader;
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::  ȣ  ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<form action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=config>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=ps value=new>\n";
    print "<tr><td>ο йȣ</td><td align=right> <input type=password name=newpasswd size=10 maxlength=8></td></tr>\n";
    print "<tr><td>йȣ Է</td><td align=right> <input type=password name=repasswd size=10 maxlength=8></td></tr>\n";
    print "<tr><td>\n";
    if($gMakeBoard eq "Y") {
        $gMakeBoard = "";
    } 
    else {
        $gMakeBoard = "";
    }
    print "<tr><td align=right>Խ ߰:</td><td><font color=#ff0000><b>$gMakeBoard</b></font></td></tr>\n";
    print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::    ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<tr><td> </td><td align=right><input type=text name=BackColor value=\"$gBackColor\" size=10></td></tr>\n";
    print "<tr><td> ׸</td><td align=right><input type=text name=BackImage value=\"$gBackImage\" size=40></td></tr>\n";
    print "<tr><td>׸ ġ</td><td align=right><input type=text name=BackImagePosition1 value=\"$gBackImagePosition1\" size=18>&nbsp;&nbsp;&nbsp;<input type=text name=BackImagePosition2 value=\"$gBackImagePosition2\" size=18></td></tr>\n";
	print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::    ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<tr><td> </td><td align=right><input type=text name=BoardTitle value=\"$gBoardTitle\" size=40></td></tr>\n";
    print "<tr><td> ׸</td><td align=right><input type=text name=BoardImage value=\"$gBoardImage\" size=40></td></tr>\n";
    print "<tr><td> </td><td align=right><input type=text name=TitleColor value=\"$gTitleColor\" size=10></td></tr>\n";
	print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> ::: ⺻ ȯ  ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0>\n";    
    print "<tr><td>Ų </td><td align=right><input type=text name=Skin value=\"$gSkin\" size=10></td></tr>\n";
	print "<tr><td>⺻ ڻ</td><td align=right><input type=text name=BaseText value=\"$gBaseText\" size=10></td></tr>\n";
    print "<tr><td>⺻ ũ</td><td align=right><input type=text name=TextSize value=\"$gTextSize\" size=10></td></tr>\n";
    print "<tr><td>⺻ ۲</td><td align=right><input type=text name=TextFamily value=\"$gTextFamily\" size=10></td></tr>\n";
    print "<tr><td>ũ </td><td align=right><input type=text name=Link value=\"$gLink\" size=10></td></tr></td></tr>\n";
    print "<tr><td>湮 ũ</td><td align=right><input type=text name=LinkVisited value=\"$gLinkVisited\" size=10></td></tr>\n";
    print "<tr><td>Ȱȭ ũ</td><td align=right><input type=text name=LinkActive value=\"$gLinkActive\" size=10></td></tr>\n";
    print "<tr><td>ũ hover</td><td align=right><input type=text name=LinkHover value=\"$gLinkHover\" size=10></td></tr>\n";
    print "<tr><td>list hover</td><td align=right><input type=text name=ListHover value=\"$gListHover\" size=10></td></tr>\n";
	print "<tr><td>Խ </td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=10></td></tr>\n";
	print "<tr><td>  </td><td align=right><input type=text name=TableCell value=\"$gTableCell\" size=10></td></tr>\n";
    print "<tr><td>  </td><td align=right><input type=text name=HeaderText value=\"$gHeaderText\" size=10></td></tr>\n";
	print "<tr><td>ǥ </td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=10></td></tr>\n";
    print "<tr><td> </td><td align=right><input type=text name=ListNumber value=\"$gListNumber\" size=10></td></tr>\n";
    print "<tr><td>  </td><td align=right><input type=text name=ThreadNumber value=\"$gThreadNumber\" size=10></td></tr>\n";
    print "<tr><td≯ Է </td><td align=right><input type=text name=NameMaxlength value=\"$gNameMaxlength\" size=10></td></tr>\n";
    print "<tr><td> Է </td><td align=right><input type=text name=SubjectMaxlength value=\"$gSubjectMaxlength\" size=10></td></tr>\n";
	print "<tr><td> 뺸</td><td align=right><select name=MailInform>";
    if($gMailInform eq "Y") {
        print "<option value=Y selected>Ѵ";
        print "<option value=N>";
    }
    else {
        print "<option value=Y>Ѵ";
        print "<option value=N selected>";
    }
    print "</select></td></tr>\n";
    print "<tr><td>ڸ ۾</td><td align=right><select name=Administ>";
    if($gAdminist eq "Y") {
        print "<option value=Y selected>Ѵ";
        print "<option value=N>";
    }
    else {
        print "<option value=Y>Ѵ";
        print "<option value=N selected>";
    }
    print "</select></td></tr>\n";
    print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::  ũѹ  ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<tr><td>scrollbar-face-color</td><td align=right><input type=text name=ScrollbarFace value=\"$gScrollbarFace\" size=10></td></tr>\n";
    print "<tr><td>scrollbar-shadow-color</td><td align=right><input type=text name=ScrollbarShadow value=\"$gScrollbarShadow\" size=10></td></tr>\n";
    print "<tr><td>scrollbar-highlight-color</td><td align=right><input type=text name=ScrollbarHighlight value=\"$gScrollbarHighlight\" size=10></td></tr>\n";
    print "<tr><td>scrollbar-3dlight-color</td><td align=right><input type=text name=Scrollbar3dlight value=\"$gScrollbar3dlight\" size=10></td></tr>\n";
    print "<tr><td>scrollbar-darkshadow-color</td><td align=right><input type=text name=ScrollbarDarkshadow value=\"$gScrollbarDarkshadow\" size=10></td></tr>\n";
    print "<tr><td>scrollbar-track-color</td><td align=right><input type=text name=ScrollbarTrack value=\"$gScrollbarTrack\" size=10></td></tr>\n";
    print "<tr><td>scrollbar-arrow-color</td><td align=right><input type=text name=ScrollbarArrow value=\"$gScrollbarArrow\" size=10></td></tr>\n";
	print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> ::: ΰ   ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<tr><td>Admin E-Mail</td><td align=right><input type=text name=AdminEmail value=\"$gAdminEmail\" size=40></td></tr>\n";
    print "<tr><td>Sendmail Path</td><td align=right><input type=text name=EmailPgm value=\"$gEmailPgm\" size=40></td></tr>\n";
    print "<tr><td>URL</td><td align=right><input type=text name=HomeURL value=\"$gHomeURL\" size=40></td></tr>\n";
    print "<tr><td>Target</td><td align=right><input type=text name=HomeURLTarget value=\"$gHomeURLTarget\" size=10></td></tr>\n";
    print "</table></td></tr></table>\n";
    print "<p><input type=submit value=\"- submit -\" class=submit>\n";
    print "</form>\n";
    &HTMLFooter;
}

sub updateEnvVar {
    &checkAdminPassword if($FORM{'newpasswd'} || $FORM{'repassword'});

    $gBackColor = $FORM{'BackColor'};
    $gBackImage = $FORM{'BackImage'} if($FORM{'BackImage'} =~ /^http:\/\// || $FORM{'BackImage'} eq "");
    $gBoardTitle = $FORM{'BoardTitle'};
    $gBoardImage = $FORM{'BoardImage'} if($FORM{'BoardImage'} =~ /^http:\/\// || $FORM{'BoardImage'} eq "");
    $gTableWidth = $FORM{'TableWidth'};         
    $gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);
    $gThreadNumber = $FORM{'ThreadNumber'} if($FORM{'ThreadNumber'} >= 1);
    $gMailInform = $FORM{'MailInform'};
    $gAdminEmail = $FORM{'AdminEmail'} if($FORM{'AdminEmail'} =~ /.+\@.+(\..+)+/ || $FORM{'AdminEmail'} eq "");
    $gEmailPgm = $FORM{'EmailPgm'};
    $gHomeURL = $FORM{'HomeURL'};
    $gHomeURLTarget = $FORM{'HomeURLTarget'};
    $gBaseText = $FORM{'BaseText'};
    $gLink = $FORM{'Link'};
    $gLinkVisited = $FORM{'LinkVisited'};
    $gLinkActive = $FORM{'LinkActive'};
    $gLinkHover = $FORM{'LinkHover'};
    $gListHover = $FORM{'ListHover'};
    $gAdminist = $FORM{'Administ'};
    $gTextSize = $FORM{'TextSize'};
    $gTextFamily = $FORM{'TextFamily'};
    $gListNumber = $FORM{'ListNumber'};
    $gTableCell = $FORM{'TableCell'};
    $gHeaderText = $FORM{'HeaderText'};
    $gTitleColor = $FORM{'TitleColor'};
    $gNameMaxlength = $FORM{'NameMaxlength'};
    $gSubjectMaxlength = $FORM{'SubjectMaxlength'};
    $gScrollbarFace = $FORM{'ScrollbarFace'};
    $gScrollbarShadow = $FORM{'ScrollbarShadow'};
    $gScrollbarHighlight = $FORM{'ScrollbarHighlight'};
    $gScrollbar3dlight = $FORM{'Scrollbar3dlight'};
    $gScrollbarDarkshadow = $FORM{'ScrollbarDarkshadow'};
    $gScrollbarTrack = $FORM{'ScrollbarTrack'};
    $gScrollbarArrow = $FORM{'ScrollbarArrow'};
    $gSkin = $FORM{'Skin'};
    $gBackImagePosition1 = $FORM{'BackImagePosition1'};
    $gBackImagePosition2 = $FORM{'BackImagePosition2'};
    &putEnvVar;
    $gCurPage = $FORM{'p'};
    &readData;
}

sub lock {
    local($LockFile) = "$gBaseDIR/lock.txt";
    local($EndTime) = time+45;
    
    while (-s $LockFile && time < $EndTime) {
        sleep(1);
    }
    open(LOCK, ">$LockFile");
        print LOCK "lock";
    close(LOCK);
}

sub unlock {
    local($LockFile) = "$gBaseDIR/lock.txt";
    
    open(LOCK, ">$LockFile");
        print LOCK "";
    close(LOCK);
}
